set term png size 800,600 enhanced font "Ubuntu,10"
set output outfile

set multiplot layout 2,2
set key at screen 0.75,screen 0.9 horizontal
#set key right top outside
#set xrange[-0.5:1]
set yrange[0:]
set auto x
set style data histogram
set style histogram cluster gap 1
set style fill solid 1.0
set boxwidth 0.9
unset xtics

set origin 0,0
set size 0.5, 0.4
set title "Duration"
set ylabel 'second'
plot infile every ::0::0 using 2 ti col, '' every ::0::0 u 3 ti col,'' every ::0::0 u 4 ti col,'' every ::0::0 u 5 ti col,'' every ::0::0 u 6 ti col

set origin 0.5,0.0
set size 0.5, 0.4
set title "RouteLength"
set ylabel 'meter'
unset key
plot infile every ::1::1 using 2:xtic(1) ti col, '' every ::1::1 u 3 ti col,'' every ::1::1 u 4 ti col,'' every ::1::1 u 5 ti col,'' every ::1::1 u 6 ti col

set origin 0,0.4
set size 0.5, 0.4
set title "WaitSteps"
set ylabel 'step'
unset key
plot infile every ::2::2 using 2:xtic(1) ti col, '' every ::2::2 u 3 ti col,'' every ::2::2 u 4 ti col,'' every ::2::2 u 5 ti col,'' every ::2::2 u 6 ti col

set origin 0.5,0.4
set size 0.5, 0.4
set title "TimeLoss"
set ylabel 'second'
unset key
plot infile every ::3::3 using 2:xtic(1) ti col, '' every ::3::3 u 3 ti col,'' every ::3::3 u 4 ti col,'' every ::3::3 u 5 ti col,'' every ::3::3 u 6 ti col

unset multiplot
